| Flutter Impeller |

Public Member Functions | Static Public Member Functions | List of all members
impeller::TRect< T > Struct Template Reference

`#include <rect.h>`

## Public Member Functions
constexpr | TRect ()
constexpr bool | operator== (const TRect &r) const
constexpr bool | operator!= (const TRect &r) const
constexpr TRect | Scale (Type scale) const
constexpr TRect | Scale (Type scale_x, Type scale_y) const
constexpr TRect | Scale (TPoint< T > scale) const
constexpr TRect | Scale (TSize< T > scale) const
constexpr bool | Contains (const TPoint< Type > &p) const
| Returns true iff the provided point |p| is inside the half-open interior of this rectangle. More...
constexpr bool | ContainsInclusive (const TPoint< Type > &p) const
| Returns true iff the provided point |p| is inside the closed-range interior of this rectangle. More...
constexpr bool | Contains (const TRect &o) const
| Returns true iff this rectangle is not empty and it also contains every point considered inside the provided rectangle |o| (as determined by |Contains(TPoint)|). More...
| IsFinite () const
| Returns true if all of the fields of this floating point rectangle are finite. More...
constexpr bool | IsEmpty () const
| Returns true if either of the width or height are 0, negative, or NaN. More...
constexpr bool | IsSquare () const
| Returns true if width and height are equal and neither is NaN. More...
constexpr bool | IsMaximum () const
constexpr TPoint< Type > | GetOrigin () const
| Returns the upper left corner of the rectangle as specified by the left/top or x/y values when it was constructed. More...
constexpr TSize< Type > | GetSize () const
| Returns the size of the rectangle which may be negative in either width or height and may have been clipped to the maximum integer values for integer rects whose size overflows. More...
constexpr Type | GetX () const
| Returns the X coordinate of the upper left corner, equivalent to |GetOrigin().x|. More...
constexpr Type | GetY () const
| Returns the Y coordinate of the upper left corner, equivalent to |GetOrigin().y|. More...
constexpr Type | GetWidth () const
| Returns the width of the rectangle, equivalent to |GetSize().width|. More...
constexpr Type | GetHeight () const
| Returns the height of the rectangle, equivalent to |GetSize().height|. More...
constexpr auto | GetLeft () const
constexpr auto | GetTop () const
constexpr auto | GetRight () const
constexpr auto | GetBottom () const
constexpr TPoint< T > | GetLeftTop () const
constexpr TPoint< T > | GetRightTop () const
constexpr TPoint< T > | GetLeftBottom () const
constexpr TPoint< T > | GetRightBottom () const
constexpr T | Area () const
| Get the area of the rectangle, equivalent to |GetSize().Area()|. More...
constexpr Point | GetCenter () const
| Get the center point as a |Point|. More...
constexpr std::array< T, 4 > | GetLTRB () const
constexpr std::array< T, 4 > | GetXYWH () const
| Get the x, y coordinates of the origin and the width and height of the rectangle in an array. More...
constexpr TRect | GetPositive () const
| Get a version of this rectangle that has a non-negative size. More...
constexpr std::array< TPoint< T >, 4 > | GetPoints () const
| Get the points that represent the 4 corners of this rectangle in a Z order that is compatible with triangle strips or a set of all zero points if the rectangle is empty. The order is: Top left, top right, bottom left, bottom right. More...
constexpr std::array< TPoint< T >, 4 > | GetTransformedPoints (const Matrix &transform) const
constexpr TRect | TransformAndClipBounds (const Matrix &transform) const
| Creates a new bounding box that contains this transformed rectangle, clipped against the near clipping plane if necessary. More...
constexpr TRect | TransformBounds (const Matrix &transform) const
| Creates a new bounding box that contains this transformed rectangle. More...
constexpr Matrix | GetNormalizingTransform () const
| Constructs a Matrix that will map all points in the coordinate space of the rectangle into a new normalized coordinate space where the upper left corner of the rectangle maps to (0, 0) and the lower right corner of the rectangle maps to (1, 1). More...
constexpr TRect | Union (const TRect &o) const
constexpr std::optional< TRect > | Intersection (const TRect &o) const
constexpr bool | IntersectsWithRect (const TRect &o) const
constexpr std::optional< TRect< T > > | Cutout (const TRect &o) const
| Returns the new boundary rectangle that would result from this rectangle being cut out by the specified rectangle. More...
constexpr TRect | CutoutOrEmpty (const TRect &o) const
constexpr TRect< T > | Shift (T dx, T dy) const
| Returns a new rectangle translated by the given offset. More...
constexpr TRect< T > | Shift (TPoint< T > offset) const
| Returns a new rectangle translated by the given offset. More...
constexpr TRect< T > | Expand (T left, T top, T right, T bottom) const
| Returns a rectangle with expanded edges. Negative expansion results in shrinking. More...
constexpr TRect< T > | Expand (T amount) const
| Returns a rectangle with expanded edges in all directions. Negative expansion results in shrinking. More...
constexpr TRect< T > | Expand (T horizontal_amount, T vertical_amount) const
| Returns a rectangle with expanded edges in all directions. Negative expansion results in shrinking. More...
constexpr TRect< T > | Expand (TPoint< T > amount) const
| Returns a rectangle with expanded edges in all directions. Negative expansion results in shrinking. More...
constexpr TRect< T > | Expand (TSize< T > amount) const
| Returns a rectangle with expanded edges in all directions. Negative expansion results in shrinking. More...
constexpr TRect< T > | Project (TRect< T > source) const
| Returns a new rectangle that represents the projection of the source rectangle onto this rectangle. In other words, the source rectangle is redefined in terms of the coordinate space of this rectangle. More...
| RoundOut (const TRect< U > &r)
| Round (const TRect< U > &r)

## Static Public Member Functions
constexpr static TRect | MakeLTRB (Type left, Type top, Type right, Type bottom)
constexpr static TRect | MakeXYWH (Type x, Type y, Type width, Type height)
constexpr static TRect | MakeOriginSize (const TPoint< Type > &origin, const TSize< Type > &size)
template<class U >
constexpr static TRect | MakeSize (const TSize< U > &size)
template<typename U >
constexpr static std::optional< TRect > | MakePointBounds (const U &value)
template<typename PointIter >
constexpr static std::optional< TRect > | MakePointBounds (const PointIter first, const PointIter last)
constexpr static TRect | MakeMaximum ()
constexpr static std::optional< TRect > | Union (const TRect &a, const std::optional< TRect > b)
constexpr static std::optional< TRect > | Union (const std::optional< TRect > a, const TRect &b)
constexpr static std::optional< TRect > | Union (const std::optional< TRect > a, const std::optional< TRect > b)
constexpr static std::optional< TRect > | Intersection (const TRect &a, const std::optional< TRect > b)
constexpr static std::optional< TRect > | Intersection (const std::optional< TRect > a, const TRect &b)
constexpr static std::optional< TRect > | Intersection (const std::optional< TRect > a, const std::optional< TRect > b)

## Detailed Description

### template<class T>
struct impeller::TRect< T >

Templated struct for holding an axis-aligned rectangle.

Rectangles are defined as 4 axis-aligned edges that might contain space. They can be viewed as 2 X coordinates that define the left and right edges and 2 Y coordinates that define the top and bottom edges; or they can be viewed as an origin and horizontal and vertical dimensions (width and height).

When the left and right edges are equal or reversed (right <= left) or the top and bottom edges are equal or reversed (bottom <= top), the rectangle is considered empty. Considering the rectangle in XYWH form, the width and/or the height would be negative or zero. Such reversed/empty rectangles contain no space and act as such in the methods that operate on them (Intersection, Union, IntersectsWithRect, Contains, Cutout, etc.)

Rectangles cannot be modified by any method and a new value can only be stored into an existing rect using assignment. This keeps the API clean compared to implementations that might have similar methods that produce the answer in place, or construct a new object with the answer, or place the result in an indicated result object.

Methods that might fail to produce an answer will use |std::optional| to indicate that success or failure (see |Intersection| and |CutOut|). For convenience, |Intersection| and |Union| both have overloaded variants that take |std::optional| arguments and treat them as if the argument was an empty rect to allow chaining multiple such methods and only needing to check the optional condition of the final result. The primary methods also provide |...OrEmpty| overloaded variants that translate an empty optional answer into a simple empty rectangle of the same type.

Rounding instance methods are not provided as the return value might be wanted as another floating point rectangle or sometimes as an integer rectangle. Instead a |RoundOut| factory, defined only for floating point input rectangles, is provided to provide control over the result type.

NaN and Infinity values

Constructing an LTRB rectangle using Infinity values should work as expected with either 0 or +Infinity returned as dimensions depending on which side the Infinity values are on and the sign.

Constructing an XYWH rectangle using Infinity values will usually not work if the math requires the object to compute a right or bottom edge from ([xy] -Infinity + [wh] +Infinity). Other combinations might work.

The special factory |MakeMaximum| is provided to construct a rectangle of the indicated coordinate type that covers all finite coordinates. It does not use infinity values, but rather the largest finite values to avoid math that might produce a NaN value from various getters.

Any rectangle that is constructed with, or computed to have a NaN value will be considered the same as any empty rectangle.

Empty Rectangle canonical results summary:

Union will ignore any empty rects and return the other rect Intersection will return nullopt if either rect is empty IntersectsWithRect will return false if either rect is empty Cutout will return the source rect if the argument is empty Cutout will return nullopt if the source rectangle is empty Contains(Point) will return false if the source rectangle is empty Contains(Rect) will return false if the source rectangle is empty Contains(Rect) will otherwise return true if the argument is empty Specifically, EmptyRect.Contains(EmptyRect) returns false

Special notes on problems using the XYWH form of specifying rectangles:

It is possible to have integer rectangles whose dimensions exceed the maximum number that their coordinates can represent since (MAX_INT - MIN_INT) overflows the representable positive numbers. Floating point rectangles technically have a similar issue in that overflow can occur, but it will be automatically converted into either an infinity, or a finite-overflow value and still be representable, just with little to no precision.

Secondly, specifying a rectangle using XYWH leads to cases where the math for (x+w) and/or (y+h) are also beyond the maximum representable coordinates. For N-bit integer rectangles declared as XYWH, the maximum right coordinate will require N+1 signed bits which cannot be stored in storage that uses N-bit integers.

Saturated math is used when constructing a rectangle from XYWH values and when returning the dimensions of the rectangle. Constructing an integer rectangle from values such that xy + wh is beyond the range of the integer type will place the right or bottom edges at the maximum value for the integer type. Similarly, constructing an integer rectangle such that the distance from the left to the right (or top to bottom) is greater than the range of the integer type will simply return the maximum integer value as the dimension. Floating point rectangles are naturally saturated by the rules of IEEE arithmetic.

Definition at line 122 of file rect.h.

## Constructor & Destructor Documentation

## ◆ TRect()

template<class T >

constexpr impeller::TRect< T >::TRect | ( |  | ) |
| inline constexpr

Definition at line 127 of file rect.h.

127 : left_(0), top_(0), right_(0), bottom_(0) {}

Referenced by impeller::TRect< Scalar >::CutoutOrEmpty(), impeller::TRect< Scalar >::MakeLTRB(), impeller::TRect< Scalar >::MakeSize(), impeller::TRect< Scalar >::MakeXYWH(), and impeller::TRect< Scalar >::Scale().

## Member Function Documentation

## ◆ Area()

template<class T >

constexpr T impeller::TRect< T >::Area | ( |  | ) | const
| inline constexpr

Get the area of the rectangle, equivalent to |GetSize().Area()|.

Definition at line 366 of file rect.h.

366 {
367 // TODO(flutter/flutter#141710) - Use saturated math to avoid overflow
368 // https://github.com/flutter/flutter/issues/141710
369 return IsEmpty() ? 0 : (right_ - left_) * (bottom_ - top_);
370 }

Referenced by impeller::BlitPass::AddCopy(), and impeller::BlitCopyBufferToTextureCommandGLES::Encode().

## ◆ Contains() [1/2]

template<class T >

constexpr bool impeller::TRect< T >::Contains | ( | const TPoint< Type > & | p | ) | const
| inline constexpr

Returns true iff the provided point |p| is inside the half-open interior of this rectangle.

For purposes of containment, a rectangle contains points along the top and left edges but not points along the right and bottom edges so that a point is only ever considered inside one of two abutting rectangles.

Definition at line 221 of file rect.h.

221 {
222 return !this->IsEmpty() && //
223 p.x >= left_ && //
224 p.y >= top_ && //
225 p.x < right_ && //
226 p.y < bottom_;
227 }

Referenced by impeller::RectGeometry::CoversArea(), impeller::RoundRectGeometry::CoversArea(), impeller::FillPathGeometry::CoversArea(), impeller::TiledTextureContents::RenderToSnapshot(), and impeller::testing::TEST().

## ◆ Contains() [2/2]

template<class T >

constexpr bool impeller::TRect< T >::Contains | ( | const TRect< T > & | o | ) | const
| inline constexpr

Returns true iff this rectangle is not empty and it also contains every point considered inside the provided rectangle |o| (as determined by |Contains(TPoint)|).

This is similar to a definition where the result is true iff the union of the two rectangles is equal to this rectangle, ignoring precision issues with performing those operations and assuming that empty rectangles are never equal.

An empty rectangle can contain no other rectangle.

An empty rectangle is, however, contained within any other non-empy rectangle as the set of points it contains is an empty set and so there are no points to fail the containment criteria.

Definition at line 263 of file rect.h.

263 {
264 return !this->IsEmpty() && //
265 (o.IsEmpty() || (o.left_ >= left_ && //
266 o.top_ >= top_ && //
267 o.right_ <= right_ && //
268 o.bottom_ <= bottom_));
269 }

## ◆ ContainsInclusive()

template<class T >

constexpr bool impeller::TRect< T >::ContainsInclusive | ( | const TPoint< Type > & | p | ) | const
| inline constexpr

Returns true iff the provided point |p| is inside the closed-range interior of this rectangle.

Unlike the regular |Contains(TPoint)| method, this method considers all points along the boundary of the rectangle to be contained within the rectangle - useful for testing if vertices that define a filled shape would carry the interior of that shape outside the bounds of the rectangle. Since both geometries are defining half-open spaces, their defining geometry needs to consider their boundaries to be equivalent with respect to interior and exterior.

Definition at line 240 of file rect.h.

240 {
241 return !this->IsEmpty() && //
242 p.x >= left_ && //
243 p.y >= top_ && //
244 p.x <= right_ && //
245 p.y <= bottom_;
246 }

Referenced by impeller::testing::TEST().

## ◆ Cutout()

template<class T >

constexpr std::optional<TRect<T> > impeller::TRect< T >::Cutout | ( | const TRect< T > & | o | ) | const
| inline constexpr

Returns the new boundary rectangle that would result from this rectangle being cut out by the specified rectangle.

Definition at line 544 of file rect.h.

544 {
545 if (IsEmpty()) {
546 // This test isn't just a short-circuit, it also prevents the concise
547 // math below from returning the wrong answer on empty rects.
548 // Once we know that this rectangle is not empty, the math below can
549 // only succeed in computing a value if o is also non-empty and non-nan.
550 // Otherwise, the method returns *this by default.
551 return std::nullopt;
552 }
553
554 const auto& [a_left, a_top, a_right, a_bottom] = GetLTRB(); // Source rect.
555 const auto& [b_left, b_top, b_right, b_bottom] = o.GetLTRB(); // Cutout.
556 if (b_left <= a_left && b_right >= a_right) {
557 if (b_top <= a_top && b_bottom >= a_bottom) {
558 // Full cutout.
559 return std::nullopt;
560 }
561 if (b_top <= a_top && b_bottom > a_top) {
562 // Cuts off the top.
563 return TRect::MakeLTRB(a_left, b_bottom, a_right, a_bottom);
564 }
565 if (b_bottom >= a_bottom && b_top < a_bottom) {
566 // Cuts off the bottom.
567 return TRect::MakeLTRB(a_left, a_top, a_right, b_top);
568 }
569 }
570 if (b_top <= a_top && b_bottom >= a_bottom) {
571 if (b_left <= a_left && b_right > a_left) {
572 // Cuts off the left.
573 return TRect::MakeLTRB(b_right, a_top, a_right, a_bottom);
574 }
575 if (b_right >= a_right && b_left < a_right) {
576 // Cuts off the right.
577 return TRect::MakeLTRB(a_left, a_top, b_left, a_bottom);
578 }
579 }
580
581 return *this;
582 }

Referenced by impeller::TRect< Scalar >::CutoutOrEmpty(), and impeller::testing::TEST().

## ◆ CutoutOrEmpty()

template<class T >

constexpr TRect impeller::TRect< T >::CutoutOrEmpty | ( | const TRect< T > & | o | ) | const
| inline constexpr

Definition at line 584 of file rect.h.

584 {
585 return Cutout(o).value_or(TRect());
586 }

Referenced by impeller::testing::TEST().

## ◆ Expand() [1/5]

template<class T >

constexpr TRect<T> impeller::TRect< T >::Expand | ( | T | amount | ) | const
| inline constexpr

Returns a rectangle with expanded edges in all directions. Negative expansion results in shrinking.

Definition at line 619 of file rect.h.

619 {
620 return {
621 saturated::Sub(left_, amount), //
622 saturated::Sub(top_, amount), //
623 saturated::Add(right_, amount), //
624 saturated::Add(bottom_, amount), //
625 };
626 }

## ◆ Expand() [2/5]

template<class T >

constexpr TRect<T> impeller::TRect< T >::Expand | ( | T | horizontal_amount,
|  | T | vertical_amount
| ) |  | const
| inline constexpr

Returns a rectangle with expanded edges in all directions. Negative expansion results in shrinking.

Definition at line 630 of file rect.h.

631 {
632 return {
633 saturated::Sub(left_, horizontal_amount), //
634 saturated::Sub(top_, vertical_amount), //
635 saturated::Add(right_, horizontal_amount), //
636 saturated::Add(bottom_, vertical_amount), //
637 };
638 }

## ◆ Expand() [3/5]

template<class T >

constexpr TRect<T> impeller::TRect< T >::Expand | ( | T | left,
|  | T | top,
|  | T | right,
|  | T | bottom
| ) |  | const
| inline constexpr

Returns a rectangle with expanded edges. Negative expansion results in shrinking.

Definition at line 605 of file rect.h.

608 {
609 return {
610 saturated::Sub(left_, left), //
611 saturated::Sub(top_, top), //
612 saturated::Add(right_, right), //
613 saturated::Add(bottom_, bottom), //
614 };
615 }

Referenced by impeller::Canvas::ClipRRect(), impeller::RoundRectGeometry::CoversArea(), impeller::TRect< Scalar >::Expand(), impeller::BorderMaskBlurFilterContents::GetFilterCoverage(), impeller::BorderMaskBlurFilterContents::GetFilterSourceCoverage(), impeller::DirectionalMorphologyFilterContents::GetFilterSourceCoverage(), impeller::GaussianBlurFilterContents::GetFilterSourceCoverage(), impeller::TextureContents::Render(), and impeller::testing::TEST_P().

## ◆ Expand() [4/5]

template<class T >

constexpr TRect<T> impeller::TRect< T >::Expand | ( | TPoint< T > | amount | ) | const
| inline constexpr

Returns a rectangle with expanded edges in all directions. Negative expansion results in shrinking.

Definition at line 642 of file rect.h.

642 {
643 return Expand(amount.x, amount.y);
644 }

## ◆ Expand() [5/5]

template<class T >

constexpr TRect<T> impeller::TRect< T >::Expand | ( | TSize< T > | amount | ) | const
| inline constexpr

Returns a rectangle with expanded edges in all directions. Negative expansion results in shrinking.

Definition at line 648 of file rect.h.

648 {
649 return Expand(amount.width, amount.height);
650 }

## ◆ GetBottom()

template<class T >

constexpr auto impeller::TRect< T >::GetBottom | ( |  | ) | const
| inline constexpr

Definition at line 347 of file rect.h.

347 { return bottom_; }

Referenced by impeller::BlitPass::AddCopy(), impeller::Canvas::Canvas(), impeller::DlDispatcherBase::drawDisplayList(), impeller::NinePatchConverter::DrawNinePatch(), RectNear(), impeller::testing::swap_nan(), and impeller::testing::TEST().

## ◆ GetCenter()

template<class T >

constexpr Point impeller::TRect< T >::GetCenter | ( |  | ) | const
| inline constexpr

Get the center point as a |Point|.

Definition at line 373 of file rect.h.

373 {
374 return {saturated::AverageScalar(left_, right_),
375 saturated::AverageScalar(top_, bottom_)};
376 }

Referenced by impeller::PathBuilder::AddArc(), impeller::PathBuilder::AddOval(), impeller::Canvas::DrawOval(), and impeller::Tessellator::FilledEllipse().

## ◆ GetHeight()

template<class T >

constexpr Type impeller::TRect< T >::GetHeight | ( |  | ) | const
| inline constexpr

Returns the height of the rectangle, equivalent to |GetSize().height|.

Definition at line 337 of file rect.h.

337 {
338 return saturated::Sub(bottom_, top_);
339 }

Referenced by impeller::Canvas::ClipRRect(), impeller::RoundRectGeometry::CoversArea(), impeller::DrawGlyph(), impeller::BlitCopyBufferToTextureCommandGLES::Encode(), impeller::BlitCopyTextureToTextureCommandGLES::Encode(), impeller::BlitCopyTextureToBufferCommandGLES::Encode(), impeller::Tessellator::FilledRoundRect(), impeller::TRect< Scalar >::GetNormalizingTransform(), impeller::TRect< Scalar >::GetSize(), impeller::TRect< Scalar >::GetXYWH(), impeller::TRect< Scalar >::Project(), impeller::PassBindingsCacheMTL::SetScissor(), impeller::PassBindingsCacheMTL::SetViewport(), and impeller::testing::TEST().

## ◆ GetLeft()

template<class T >

constexpr auto impeller::TRect< T >::GetLeft | ( |  | ) | const
| inline constexpr

Definition at line 341 of file rect.h.

341 { return left_; }

Referenced by impeller::Canvas::Canvas(), impeller::DlDispatcherBase::drawDisplayList(), impeller::DrawGlyph(), impeller::NinePatchConverter::DrawNinePatch(), RectNear(), impeller::testing::swap_nan(), and impeller::testing::TEST().

## ◆ GetLeftBottom()

template<class T >

constexpr TPoint<T> impeller::TRect< T >::GetLeftBottom | ( |  | ) | const
| inline constexpr

Definition at line 357 of file rect.h.

357 {
358 return {left_, bottom_};
359 }

Referenced by impeller::TextureContents::Render(), and impeller::testing::TEST().

## ◆ GetLeftTop()

template<class T >

constexpr TPoint<T> impeller::TRect< T >::GetLeftTop | ( |  | ) | const
| inline constexpr

Definition at line 349 of file rect.h.

349 { //
350 return {left_, top_};
351 }

Referenced by impeller::Tessellator::FilledRoundRect(), impeller::TextureContents::Render(), impeller::TextContents::Render(), and impeller::testing::TEST().

## ◆ GetLTRB()

template<class T >

constexpr std::array<T, 4> impeller::TRect< T >::GetLTRB | ( |  | ) | const
| inline constexpr

Definition at line 378 of file rect.h.

378 {
379 return {left_, top_, right_, bottom_};
380 }

Referenced by impeller::TRect< Scalar >::Cutout().

## ◆ GetNormalizingTransform()

template<class T >

constexpr Matrix impeller::TRect< T >::GetNormalizingTransform | ( |  | ) | const
| inline constexpr

Constructs a Matrix that will map all points in the coordinate space of the rectangle into a new normalized coordinate space where the upper left corner of the rectangle maps to (0, 0) and the lower right corner of the rectangle maps to (1, 1).

Empty and non-finite rectangles will return a zero-scaling transform that maps all points to (0, 0).

Definition at line 482 of file rect.h.

482 {
483 if (!IsEmpty()) {
484 Scalar sx = 1.0 / GetWidth();
485 Scalar sy = 1.0 / GetHeight();
486 Scalar tx = left_ * -sx;
487 Scalar ty = top_ * -sy;
488
489 // Exclude NaN and infinities and either scale underflowing to zero
490 if (sx != 0.0 && sy != 0.0 && 0.0 * sx * sy * tx * ty == 0.0) {
491 // clang-format off
492 return Matrix( sx, 0.0f, 0.0f, 0.0f,
493 0.0f, sy, 0.0f, 0.0f,
494 0.0f, 0.0f, 1.0f, 0.0f,
495 tx, ty, 0.0f, 1.0f);
496 // clang-format on
497 }
498 }
499
500 // Map all coordinates to the origin.
501 return Matrix::MakeScale({0.0f, 0.0f, 1.0f});
502 }

Referenced by impeller::VerticesGeometry::GetPositionUVColorBuffer(), and impeller::TiledTextureContents::Render().

## ◆ GetOrigin()

template<class T >

constexpr TPoint<Type> impeller::TRect< T >::GetOrigin | ( |  | ) | const
| inline constexpr

Returns the upper left corner of the rectangle as specified by the left/top or x/y values when it was constructed.

Definition at line 310 of file rect.h.

310 {
311 return {left_, top_};
312 }

Referenced by impeller::PathBuilder::AddArc(), impeller::PathBuilder::AddOval(), impeller::PathBuilder::AddRect(), impeller::PathBuilder::AddRoundedRect(), impeller::AdvancedBlend(), impeller::DirectionalMorphologyFilterContents::GetFilterCoverage(), std::operator<<(), impeller::PipelineBlend(), impeller::ExperimentalCanvas::Restore(), and impeller::testing::TEST().

## ◆ GetPoints()

template<class T >

constexpr std::array<TPoint<T>, 4> impeller::TRect< T >::GetPoints | ( |  | ) | const
| inline constexpr

Get the points that represent the 4 corners of this rectangle in a Z order that is compatible with triangle strips or a set of all zero points if the rectangle is empty. The order is: Top left, top right, bottom left, bottom right.

Definition at line 405 of file rect.h.

405 {
406 if (IsEmpty()) {
407 return {};
408 }
409 return {
410 TPoint{left_, top_},
411 TPoint{right_, top_},
412 TPoint{left_, bottom_},
413 TPoint{right_, bottom_},
414 };
415 }

Referenced by impeller::RectGeometry::GetPositionBuffer(), impeller::TRect< Scalar >::GetTransformedPoints(), impeller::ClipContents::Render(), and impeller::testing::TEST().

## ◆ GetPositive()

template<class T >

constexpr TRect impeller::TRect< T >::GetPositive | ( |  | ) | const
| inline constexpr

Get a version of this rectangle that has a non-negative size.

Definition at line 389 of file rect.h.

389 {
390 if (!IsEmpty()) {
391 return *this;
392 }
393 return {
394 std::min(left_, right_),
395 std::min(top_, bottom_),
396 std::max(left_, right_),
397 std::max(top_, bottom_),
398 };
399 }

Referenced by impeller::testing::TEST().

## ◆ GetRight()

template<class T >

constexpr auto impeller::TRect< T >::GetRight | ( |  | ) | const
| inline constexpr

Definition at line 345 of file rect.h.

345 { return right_; }

Referenced by impeller::BlitPass::AddCopy(), impeller::Canvas::Canvas(), impeller::DlDispatcherBase::drawDisplayList(), impeller::NinePatchConverter::DrawNinePatch(), RectNear(), impeller::testing::swap_nan(), and impeller::testing::TEST().

## ◆ GetRightBottom()

template<class T >

constexpr TPoint<T> impeller::TRect< T >::GetRightBottom | ( |  | ) | const
| inline constexpr

Definition at line 361 of file rect.h.

361 {
362 return {right_, bottom_};
363 }

Referenced by impeller::Tessellator::FilledRoundRect(), impeller::TextureContents::Render(), and impeller::testing::TEST().

## ◆ GetRightTop()

template<class T >

constexpr TPoint<T> impeller::TRect< T >::GetRightTop | ( |  | ) | const
| inline constexpr

Definition at line 353 of file rect.h.

353 {
354 return {right_, top_};
355 }

Referenced by impeller::TextureContents::Render(), and impeller::testing::TEST().

## ◆ GetSize()

template<class T >

constexpr TSize<Type> impeller::TRect< T >::GetSize | ( |  | ) | const
| inline constexpr

Returns the size of the rectangle which may be negative in either width or height and may have been clipped to the maximum integer values for integer rects whose size overflows.

Definition at line 317 of file rect.h.

317 {
318 return {GetWidth(), GetHeight()};
319 }

Referenced by impeller::PathBuilder::AddRect(), impeller::PathBuilder::AddRoundedRect(), impeller::AdvancedBlend(), impeller::Canvas::DrawOval(), impeller::Tessellator::FilledEllipse(), impeller::DirectionalMorphologyFilterContents::GetFilterCoverage(), std::operator<<(), impeller::PipelineBlend(), impeller::TextContents::Render(), impeller::ExperimentalCanvas::SaveLayer(), impeller::testing::TEST(), and impeller::testing::TEST_P().

## ◆ GetTop()

template<class T >

constexpr auto impeller::TRect< T >::GetTop | ( |  | ) | const
| inline constexpr

Definition at line 343 of file rect.h.

343 { return top_; }

Referenced by impeller::Canvas::Canvas(), impeller::DlDispatcherBase::drawDisplayList(), impeller::DrawGlyph(), impeller::NinePatchConverter::DrawNinePatch(), RectNear(), impeller::testing::swap_nan(), and impeller::testing::TEST().

## ◆ GetTransformedPoints()

template<class T >

constexpr std::array<TPoint<T>, 4> impeller::TRect< T >::GetTransformedPoints | ( | const Matrix & | transform | ) | const
| inline constexpr

Definition at line 417 of file rect.h.

418 {
419 auto points = GetPoints();
420 for (size_t i = 0; i < points.size(); i++) {
421 points[i] = transform * points[i];
422 }
423 return points;
424 }

Referenced by impeller::GaussianBlurFilterContents::CalculateUVs(), impeller::Snapshot::GetCoverageUVs(), impeller::AtlasContents::Render(), impeller::testing::TEST(), and impeller::TRect< Scalar >::TransformBounds().

## ◆ GetWidth()

template<class T >

constexpr Type impeller::TRect< T >::GetWidth | ( |  | ) | const
| inline constexpr

Returns the width of the rectangle, equivalent to |GetSize().width|.

Definition at line 331 of file rect.h.

331 {
332 return saturated::Sub(right_, left_);
333 }

Referenced by impeller::Canvas::ClipRRect(), impeller::RoundRectGeometry::CoversArea(), impeller::DrawGlyph(), impeller::Canvas::DrawOval(), impeller::BlitCopyBufferToTextureCommandGLES::Encode(), impeller::BlitCopyTextureToTextureCommandGLES::Encode(), impeller::BlitCopyTextureToBufferCommandGLES::Encode(), impeller::Tessellator::FilledEllipse(), impeller::Tessellator::FilledRoundRect(), impeller::TRect< Scalar >::GetNormalizingTransform(), impeller::TRect< Scalar >::GetSize(), impeller::TRect< Scalar >::GetXYWH(), impeller::TRect< Scalar >::Project(), impeller::PassBindingsCacheMTL::SetScissor(), impeller::PassBindingsCacheMTL::SetViewport(), and impeller::testing::TEST().

## ◆ GetX()

template<class T >

constexpr Type impeller::TRect< T >::GetX | ( |  | ) | const
| inline constexpr

Returns the X coordinate of the upper left corner, equivalent to |GetOrigin().x|.

Definition at line 323 of file rect.h.

323 { return left_; }

Referenced by impeller::BlitPass::AddCopy(), impeller::DrawGlyph(), impeller::BlitCopyBufferToTextureCommandGLES::Encode(), impeller::BlitCopyTextureToTextureCommandGLES::Encode(), impeller::BlitCopyTextureToBufferCommandGLES::Encode(), impeller::PassBindingsCacheMTL::SetScissor(), impeller::PassBindingsCacheMTL::SetViewport(), and impeller::testing::TEST().

## ◆ GetXYWH()

template<class T >

constexpr std::array<T, 4> impeller::TRect< T >::GetXYWH | ( |  | ) | const
| inline constexpr

Get the x, y coordinates of the origin and the width and height of the rectangle in an array.

Definition at line 384 of file rect.h.

384 {
385 return {left_, top_, GetWidth(), GetHeight()};
386 }

Referenced by impeller::testing::TEST().

## ◆ GetY()

template<class T >

constexpr Type impeller::TRect< T >::GetY | ( |  | ) | const
| inline constexpr

Returns the Y coordinate of the upper left corner, equivalent to |GetOrigin().y|.

Definition at line 327 of file rect.h.

327 { return top_; }

Referenced by impeller::BlitPass::AddCopy(), impeller::DrawGlyph(), impeller::BlitCopyBufferToTextureCommandGLES::Encode(), impeller::BlitCopyTextureToTextureCommandGLES::Encode(), impeller::BlitCopyTextureToBufferCommandGLES::Encode(), impeller::PassBindingsCacheMTL::SetScissor(), impeller::PassBindingsCacheMTL::SetViewport(), and impeller::testing::TEST().

## ◆ Intersection() [1/4]

template<class T >

constexpr static std::optional<TRect> impeller::TRect< T >::Intersection | ( | const std::optional< TRect< T > > | a,
|  | const std::optional< TRect< T > > | b
| ) |  |
| inline static constexpr

Definition at line 711 of file rect.h.

713 {
714 return a.has_value() ? Intersection(a.value(), b) : b;
715 }

## ◆ Intersection() [2/4]

template<class T >

constexpr static std::optional<TRect> impeller::TRect< T >::Intersection | ( | const std::optional< TRect< T > > | a,
|  | const TRect< T > & | b
| ) |  |
| inline static constexpr

Definition at line 705 of file rect.h.

707 {
708 return a.has_value() ? a->Intersection(b) : b;
709 }

## ◆ Intersection() [3/4]

template<class T >

constexpr static std::optional<TRect> impeller::TRect< T >::Intersection | ( | const TRect< T > & | a,
|  | const std::optional< TRect< T > > | b
| ) |  |
| inline static constexpr

Definition at line 699 of file rect.h.

701 {
702 return b.has_value() ? a.Intersection(b.value()) : a;
703 }

## ◆ Intersection() [4/4]

template<class T >

constexpr std::optional<TRect> impeller::TRect< T >::Intersection | ( | const TRect< T > & | o | ) | const
| inline constexpr

Definition at line 519 of file rect.h.

520 {
521 if (IntersectsWithRect(o)) {
522 return TRect{
523 std::max(left_, o.left_),
524 std::max(top_, o.top_),
525 std::min(right_, o.right_),
526 std::min(bottom_, o.bottom_),
527 };
528 } else {
529 return std::nullopt;
530 }
531 }

Referenced by impeller::AdvancedBlend(), impeller::TRect< Scalar >::Intersection(), impeller::PipelineBlend(), impeller::ExperimentalCanvas::SaveLayer(), impeller::SetClipScissor(), and impeller::testing::TEST().

## ◆ IntersectsWithRect()

template<class T >

constexpr bool impeller::TRect< T >::IntersectsWithRect | ( | const TRect< T > & | o | ) | const
| inline constexpr

Definition at line 533 of file rect.h.

533 {
534 return !IsEmpty() && //
535 !o.IsEmpty() && //
536 left_ < o.right_ && //
537 top_ < o.bottom_ && //
538 right_ > o.left_ && //
539 bottom_ > o.top_;
540 }

Referenced by impeller::TRect< Scalar >::Intersection(), impeller::ExperimentalCanvas::SaveLayer(), and impeller::testing::TEST().

## ◆ IsEmpty()

template<class T >

constexpr bool impeller::TRect< T >::IsEmpty | ( |  | ) | const
| inline constexpr

Returns true if either of the width or height are 0, negative, or NaN.

Definition at line 287 of file rect.h.

287 {
288 // Computing the non-empty condition and negating the result causes any
289 // NaN value to return true - i.e. is considered empty.
290 return !(left_ < right_ && top_ < bottom_);
291 }

Referenced by impeller::TRect< Scalar >::Area(), impeller::TRect< Scalar >::Contains(), impeller::TRect< Scalar >::ContainsInclusive(), impeller::TRect< Scalar >::Cutout(), impeller::Canvas::DrawImageRect(), impeller::NinePatchConverter::DrawNinePatch(), impeller::TRect< Scalar >::GetNormalizingTransform(), impeller::TRect< Scalar >::GetPoints(), impeller::TRect< Scalar >::GetPositive(), impeller::TRect< Scalar >::IntersectsWithRect(), impeller::TRect< Scalar >::IsSquare(), impeller::TRect< Scalar >::Project(), impeller::TextureContents::Render(), impeller::testing::TEST(), impeller::TRect< Scalar >::TransformAndClipBounds(), impeller::TRect< Scalar >::TransformBounds(), and impeller::TRect< Scalar >::Union().

## ◆ IsFinite()

template<class T >

impeller::TRect< T >::IsFinite | ( |  | ) | const
| inline

Returns true if all of the fields of this floating point rectangle are finite.

Note that the results of |GetWidth()| and |GetHeight()| may still be infinite due to overflow even if the fields themselves are finite.

Definition at line 278 of file rect.h.

278 {
279 return std::isfinite(left_) && //
280 std::isfinite(top_) && //
281 std::isfinite(right_) && //
282 std::isfinite(bottom_);
283 }

Referenced by impeller::testing::TEST().

## ◆ IsMaximum()

template<class T >

constexpr bool impeller::TRect< T >::IsMaximum | ( |  | ) | const
| inline constexpr

Definition at line 304 of file rect.h.

304 {
305 return *this == MakeMaximum();
306 }

## ◆ IsSquare()

template<class T >

constexpr bool impeller::TRect< T >::IsSquare | ( |  | ) | const
| inline constexpr

Returns true if width and height are equal and neither is NaN.

Definition at line 294 of file rect.h.

294 {
295 // empty rectangles can technically be "square", but would be
296 // misleading to most callers. Using |IsEmpty| also prevents
297 // "non-empty and non-overflowing" computations from happening
298 // to be equal to "empty and overflowing" results.
299 // (Consider LTRB(10, 15, MAX-2, MIN+2) which is empty, but both
300 // w/h subtractions equal "5").
301 return !IsEmpty() && (right_ - left_) == (bottom_ - top_);
302 }

Referenced by impeller::Canvas::DrawOval(), and impeller::Tessellator::FilledEllipse().

## ◆ MakeLTRB()

template<class T >

constexpr static TRect impeller::TRect< T >::MakeLTRB | ( | Type | left,
|  | Type | top,
|  | Type | right,
|  | Type | bottom
| ) |  |
| inline static constexpr

Definition at line 129 of file rect.h.

132 {
133 return TRect(left, top, right, bottom);
134 }

Referenced by impeller::TRect< Scalar >::Cutout(), impeller::TRect< Scalar >::MakeMaximum(), impeller::TRect< Scalar >::MakePointBounds(), impeller::TRect< Scalar >::Round(), impeller::TRect< Scalar >::RoundOut(), impeller::testing::TEST(), and impeller::testing::TEST_P().

## ◆ MakeMaximum()

template<class T >

constexpr static TRect impeller::TRect< T >::MakeMaximum | ( |  | ) |
| inline static constexpr

Definition at line 174 of file rect.h.

174 {
175 return TRect::MakeLTRB(std::numeric_limits<Type>::lowest(),
176 std::numeric_limits<Type>::lowest(),
177 std::numeric_limits<Type>::max(),
178 std::numeric_limits<Type>::max());
179 }

Referenced by impeller::TRect< Scalar >::IsMaximum(), impeller::DlPlayground::OpenPlaygroundHere(), and impeller::testing::TEST().

## ◆ MakeOriginSize()

template<class T >

constexpr static TRect impeller::TRect< T >::MakeOriginSize | ( | const TPoint< Type > & | origin,
|  | const TSize< Type > & | size
| ) |  |
| inline static constexpr

Definition at line 140 of file rect.h.

141 {
142 return MakeXYWH(origin.x, origin.y, size.width, size.height);
143 }

Referenced by impeller::BlitPass::AddCopy(), and impeller::testing::TEST().

## ◆ MakePointBounds() [1/2]

template<class T >
template<typename PointIter >

constexpr static std::optional<TRect> impeller::TRect< T >::MakePointBounds | ( | const PointIter | first,
|  | const PointIter | last
| ) |  |
| inline static constexpr

Definition at line 156 of file rect.h.

157 {
158 if (first == last) {
159 return std::nullopt;
160 }
161 auto left = first->x;
162 auto top = first->y;
163 auto right = first->x;
164 auto bottom = first->y;
165 for (auto it = first + 1; it < last; ++it) {
166 left = std::min(left, it->x);
167 top = std::min(top, it->y);
168 right = std::max(right, it->x);
169 bottom = std::max(bottom, it->y);
170 }
171 return TRect::MakeLTRB(left, top, right, bottom);
172 }

## ◆ MakePointBounds() [2/2]

template<class T >
template<typename U >

constexpr static std::optional<TRect> impeller::TRect< T >::MakePointBounds | ( | const U & | value | ) |
| inline static constexpr

Definition at line 151 of file rect.h.

151 {
152 return MakePointBounds(value.begin(), value.end());
153 }

Referenced by impeller::TRect< Scalar >::MakePointBounds(), impeller::TRect< Scalar >::TransformAndClipBounds(), and impeller::TRect< Scalar >::TransformBounds().

## ◆ MakeSize()

template<class T >
template<class U >

constexpr static TRect impeller::TRect< T >::MakeSize | ( | const TSize< U > & | size | ) |
| inline static constexpr

Definition at line 146 of file rect.h.

146 {
147 return TRect(0.0, 0.0, size.width, size.height);
148 }

Referenced by impeller::RenderPass::AddCommand(), impeller::BlitPass::AddCopy(), impeller::SurfaceMTL::coverage(), impeller::TypographerContextSkia::CreateGlyphAtlas(), impeller::SetClipScissor(), and impeller::testing::TEST().

## ◆ MakeXYWH()

template<class T >

constexpr static TRect impeller::TRect< T >::MakeXYWH | ( | Type | x,
|  | Type | y,
|  | Type | width,
|  | Type | height
| ) |  |
| inline static constexpr

Definition at line 136 of file rect.h.

136 {
137 return TRect(x, y, saturated::Add(x, width), saturated::Add(y, height));
138 }

Referenced by impeller::TRect< Scalar >::MakeOriginSize(), impeller::testing::TEST(), and impeller::UpdateAtlasBitmap().

## ◆ operator!=()

template<class T >

constexpr bool impeller::TRect< T >::operator!= | ( | const TRect< T > & | r | ) | const
| inline constexpr

Definition at line 188 of file rect.h.

188 {
189 return !(*this == r);
190 }

## ◆ operator==()

template<class T >

constexpr bool impeller::TRect< T >::operator== | ( | const TRect< T > & | r | ) | const
| inline constexpr

Definition at line 181 of file rect.h.

181 {
182 return left_ == r.left_ && //
183 top_ == r.top_ && //
184 right_ == r.right_ && //
185 bottom_ == r.bottom_;
186 }

## ◆ Project()

template<class T >

constexpr TRect<T> impeller::TRect< T >::Project | ( | TRect< T > | source | ) | const
| inline constexpr

Returns a new rectangle that represents the projection of the source rectangle onto this rectangle. In other words, the source rectangle is redefined in terms of the coordinate space of this rectangle.

Definition at line 656 of file rect.h.

656 {
657 if (IsEmpty()) {
658 return {};
659 }
660 return source.Shift(-left_, -top_)
661 .Scale(1.0 / static_cast<Scalar>(GetWidth()),
662 1.0 / static_cast<Scalar>(GetHeight()));
663 }

Referenced by impeller::TextureContents::Render().

## ◆ Round()

template<class T >

impeller::TRect< T >::Round | ( | const TRect< U > & | r | ) |
| inline

Definition at line 674 of file rect.h.

674 {
675 return TRect::MakeLTRB(saturated::Cast<U, Type>(round(r.GetLeft())),
676 saturated::Cast<U, Type>(round(r.GetTop())),
677 saturated::Cast<U, Type>(round(r.GetRight())),
678 saturated::Cast<U, Type>(round(r.GetBottom())));
679 }

Referenced by impeller::testing::TEST().

## ◆ RoundOut()

template<class T >

impeller::TRect< T >::RoundOut | ( | const TRect< U > & | r | ) |
| inline

Definition at line 666 of file rect.h.

666 {
667 return TRect::MakeLTRB(saturated::Cast<U, Type>(floor(r.GetLeft())),
668 saturated::Cast<U, Type>(floor(r.GetTop())),
669 saturated::Cast<U, Type>(ceil(r.GetRight())),
670 saturated::Cast<U, Type>(ceil(r.GetBottom())));
671 }

Referenced by ImGui_ImplImpeller_RenderDrawData(), impeller::SetClipScissor(), and impeller::testing::TEST().

## ◆ Scale() [1/4]

template<class T >

constexpr TRect impeller::TRect< T >::Scale | ( | TPoint< T > | scale | ) | const
| inline constexpr

Definition at line 206 of file rect.h.

206 {
207 return Scale(scale.x, scale.y);
208 }

## ◆ Scale() [2/4]

template<class T >

constexpr TRect impeller::TRect< T >::Scale | ( | TSize< T > | scale | ) | const
| inline constexpr

Definition at line 210 of file rect.h.

210 {
211 return Scale(scale.width, scale.height);
212 }

## ◆ Scale() [3/4]

template<class T >

constexpr TRect impeller::TRect< T >::Scale | ( | Type | scale | ) | const
| inline constexpr

Definition at line 192 of file rect.h.

192 {
193 return TRect(left_ * scale, //
194 top_ * scale, //
195 right_ * scale, //
196 bottom_ * scale);
197 }

Referenced by ImGui_ImplImpeller_RenderDrawData(), impeller::TextContents::Render(), impeller::TRect< Scalar >::Scale(), and impeller::testing::TEST().

## ◆ Scale() [4/4]

template<class T >

constexpr TRect impeller::TRect< T >::Scale | ( | Type | scale_x,
|  | Type | scale_y
| ) |  | const
| inline constexpr

Definition at line 199 of file rect.h.

199 {
200 return TRect(left_ * scale_x, //
201 top_ * scale_y, //
202 right_ * scale_x, //
203 bottom_ * scale_y);
204 }

## ◆ Shift() [1/2]

template<class T >

constexpr TRect<T> impeller::TRect< T >::Shift | ( | T | dx,
|  | T | dy
| ) |  | const
| inline constexpr

Returns a new rectangle translated by the given offset.

Definition at line 589 of file rect.h.

589 {
590 return {
591 saturated::Add(left_, dx), //
592 saturated::Add(top_, dy), //
593 saturated::Add(right_, dx), //
594 saturated::Add(bottom_, dy), //
595 };
596 }

Referenced by impeller::TRect< Scalar >::Project(), impeller::SetClipScissor(), impeller::TRect< Scalar >::Shift(), and impeller::testing::TEST_P().

## ◆ Shift() [2/2]

template<class T >

constexpr TRect<T> impeller::TRect< T >::Shift | ( | TPoint< T > | offset | ) | const
| inline constexpr

Returns a new rectangle translated by the given offset.

Definition at line 599 of file rect.h.

599 {
600 return Shift(offset.x, offset.y);
601 }

## ◆ TransformAndClipBounds()

template<class T >

constexpr TRect impeller::TRect< T >::TransformAndClipBounds | ( | const Matrix & | transform | ) | const
| inline constexpr

Creates a new bounding box that contains this transformed rectangle, clipped against the near clipping plane if necessary.

Definition at line 429 of file rect.h.

430 {
431 if (!transform.HasPerspective2D()) {
432 return TransformBounds(transform);
433 }
434
435 if (IsEmpty()) {
436 return {};
437 }
438
439 auto ul = transform.TransformHomogenous({left_, top_});
440 auto ur = transform.TransformHomogenous({right_, top_});
441 auto ll = transform.TransformHomogenous({left_, bottom_});
442 auto lr = transform.TransformHomogenous({right_, bottom_});
443
444 // It can probably be proven that we only ever have 5 points at most
445 // which happens when only 1 corner is clipped and we get 2 points
446 // in return for it as we interpolate against its neighbors.
447 Point points[8];
448 int index = 0;
449
450 // Process (clip and interpolate) each point against its 2 neighbors:
451 // left, pt, right
452 index = ClipAndInsert(points, index, ll, ul, ur);
453 index = ClipAndInsert(points, index, ul, ur, lr);
454 index = ClipAndInsert(points, index, ur, lr, ll);
455 index = ClipAndInsert(points, index, lr, ll, ul);
456
457 auto bounds = TRect::MakePointBounds(points, points + index);
458 return bounds.value_or(TRect{});
459 }

Referenced by impeller::testing::TEST().

## ◆ TransformBounds()

template<class T >

constexpr TRect impeller::TRect< T >::TransformBounds | ( | const Matrix & | transform | ) | const
| inline constexpr

Creates a new bounding box that contains this transformed rectangle.

Definition at line 463 of file rect.h.

463 {
464 if (IsEmpty()) {
465 return {};
466 }
467 auto points = GetTransformedPoints(transform);
468 auto bounds = TRect::MakePointBounds(points.begin(), points.end());
469 if (bounds.has_value()) {
470 return bounds.value();
471 }
472 FML_UNREACHABLE();
473 }

Referenced by impeller::RectGeometry::CoversArea(), impeller::RoundRectGeometry::CoversArea(), impeller::TextureFilterInput::GetCoverage(), impeller::RectGeometry::GetCoverage(), impeller::Snapshot::GetCoverage(), impeller::VerticesGeometry::GetCoverage(), impeller::AtlasContents::GetCoverage(), impeller::TextureContents::GetCoverage(), impeller::MatrixFilterContents::GetFilterCoverage(), impeller::LocalMatrixFilterContents::GetFilterSourceCoverage(), impeller::ExperimentalCanvas::SaveLayer(), and impeller::TRect< Scalar >::TransformAndClipBounds().

## ◆ Union() [1/4]

template<class T >

constexpr static std::optional<TRect> impeller::TRect< T >::Union | ( | const std::optional< TRect< T > > | a,
|  | const std::optional< TRect< T > > | b
| ) |  |
| inline static constexpr

Definition at line 693 of file rect.h.

695 {
696 return a.has_value() ? Union(a.value(), b) : b;
697 }

## ◆ Union() [2/4]

template<class T >

constexpr static std::optional<TRect> impeller::TRect< T >::Union | ( | const std::optional< TRect< T > > | a,
|  | const TRect< T > & | b
| ) |  |
| inline static constexpr

Definition at line 687 of file rect.h.

689 {
690 return a.has_value() ? a->Union(b) : b;
691 }

## ◆ Union() [3/4]

template<class T >

constexpr static std::optional<TRect> impeller::TRect< T >::Union | ( | const TRect< T > & | a,
|  | const std::optional< TRect< T > > | b
| ) |  |
| inline static constexpr

Definition at line 681 of file rect.h.

683 {
684 return b.has_value() ? a.Union(b.value()) : a;
685 }

## ◆ Union() [4/4]

template<class T >

constexpr TRect impeller::TRect< T >::Union | ( | const TRect< T > & | o | ) | const
| inline constexpr

Definition at line 504 of file rect.h.

504 {
505 if (IsEmpty()) {
506 return o;
507 }
508 if (o.IsEmpty()) {
509 return *this;
510 }
511 return {
512 std::min(left_, o.left_),
513 std::min(top_, o.top_),
514 std::max(right_, o.right_),
515 std::max(bottom_, o.bottom_),
516 };
517 }

Referenced by impeller::testing::TEST(), and impeller::TRect< Scalar >::Union().

The documentation for this struct was generated from the following file:

- impeller/geometry/rect.h

impeller::TRect::GetLTRB
constexpr std::array< T, 4 > GetLTRB() const
Definition: rect.h:378
impeller::Scalar
float Scalar
Definition: scalar.h:18
impeller::TRect::MakeXYWH
constexpr static TRect MakeXYWH(Type x, Type y, Type width, Type height)
Definition: rect.h:136
impeller::TRect::TransformBounds
constexpr TRect TransformBounds(const Matrix &transform) const
Creates a new bounding box that contains this transformed rectangle.
Definition: rect.h:463
impeller::TRect::Intersection
constexpr std::optional< TRect > Intersection(const TRect &o) const
Definition: rect.h:519
impeller::TRect::TRect
constexpr TRect()
Definition: rect.h:127
impeller::TRect::GetHeight
constexpr Type GetHeight() const
Returns the height of the rectangle, equivalent to |GetSize().height|.
Definition: rect.h:337
offset
SeparatedVector2 offset
Definition: stroke_path_geometry.cc:311
impeller::TRect::IntersectsWithRect
constexpr bool IntersectsWithRect(const TRect &o) const
Definition: rect.h:533
impeller::TRect::GetPoints
constexpr std::array< TPoint< T >, 4 > GetPoints() const
Get the points that represent the 4 corners of this rectangle in a Z order that is compatible with tr...
Definition: rect.h:405
impeller::TRect::MakePointBounds
constexpr static std::optional< TRect > MakePointBounds(const U &value)
Definition: rect.h:151
impeller::TRect::Shift
constexpr TRect< T > Shift(T dx, T dy) const
Returns a new rectangle translated by the given offset.
Definition: rect.h:589
impeller::TRect::IsEmpty
constexpr bool IsEmpty() const
Returns true if either of the width or height are 0, negative, or NaN.
Definition: rect.h:287
impeller::Point
TPoint< Scalar > Point
Definition: point.h:322
impeller::TRect::GetTransformedPoints
constexpr std::array< TPoint< T >, 4 > GetTransformedPoints(const Matrix &transform) const
Definition: rect.h:417
transform
Matrix transform
Definition: gaussian_blur_filter_contents.cc:231
impeller::TRect::GetWidth
constexpr Type GetWidth() const
Returns the width of the rectangle, equivalent to |GetSize().width|.
Definition: rect.h:331
impeller::TRect::Scale
constexpr TRect Scale(Type scale) const
Definition: rect.h:192
impeller::TRect::Cutout
constexpr std::optional< TRect< T > > Cutout(const TRect &o) const
Returns the new boundary rectangle that would result from this rectangle being cut out by the specifi...
Definition: rect.h:544
impeller::TRect::MakeMaximum
constexpr static TRect MakeMaximum()
Definition: rect.h:174
impeller::saturated::b
SI b
Definition: saturated_math.h:87
scale
const Scalar scale
Definition: stroke_path_geometry.cc:308
impeller::TRect::Union
constexpr TRect Union(const TRect &o) const
Definition: rect.h:504
impeller::TRect::MakeLTRB
constexpr static TRect MakeLTRB(Type left, Type top, Type right, Type bottom)
Definition: rect.h:129
impeller::Matrix::MakeScale
static constexpr Matrix MakeScale(const Vector3 &s)
Definition: matrix.h:104
impeller::TRect::Expand
constexpr TRect< T > Expand(T left, T top, T right, T bottom) const
Returns a rectangle with expanded edges. Negative expansion results in shrinking.
Definition: rect.h:605